/* 파일 설명 적는곳

   This file is part of otak-dbmanager.

   Copyright (C) 2007 Otak-dbmanager Project.

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 3, or (at your option) any later
   version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
   Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this program; if not, write to the Free Software Foundation, Inc.,
   51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  
*/

#include <glib.h>
#include <glib-object.h>

#include "otak-lib/otak-util/otsys.h"
#include "type/odmconninfodefine.h"
#include "odmdefine.h"
#include "odmconf.h"


static gchar            *exec_abs_path  = NULL;
static gchar            *config_abs_dir = NULL;
static gchar            *glade_abs_dir  = NULL;
static gchar            *image_abs_dir  = NULL;
static OdmConnInfoProv   conn_info_prov = ODM_CONN_INFO_PROV_NONE;



/*
 * public
 */

void
odm_conf_path_init (const gchar *exec_path)
{
    exec_abs_path = ot_sys_g_free (exec_abs_path);
    exec_abs_path = g_strdup (exec_path);

    config_abs_dir  = g_strdup_printf ("%s/%s", exec_abs_path, ODM_CONFIG_DIR);
    glade_abs_dir   = g_strdup_printf ("%s/%s", exec_abs_path, ODM_GLADE_DIR);
    image_abs_dir   = g_strdup_printf ("%s/%s", exec_abs_path, ODM_IMAGE_DIR);
}

const gchar*
odm_conf_get_exec_abs_path (void)
{
    return exec_abs_path;
}

void
odm_conf_set_conn_info_prov (OdmConnInfoProv value)
{
    conn_info_prov = value;
}

OdmConnInfoProv
odm_conf_get_conn_info_prov (void)
{
    return conn_info_prov;
}

const gchar*
odm_conf_get_config_abs_dir (void)
{
    return config_abs_dir;
}

const gchar*
odm_conf_get_glade_abs_dir (void)
{
    return glade_abs_dir;
}

const gchar*
odm_conf_get_image_abs_dir (void)
{
    return image_abs_dir;
}
