/* 파일 설명 적는곳

   This file is part of otak-dbmanager.

   Copyright (C) 2007 Otak-dbmanager Project.

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 3, or (at your option) any later
   version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
   Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this program; if not, write to the Free Software Foundation, Inc.,
   51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  
*/

#ifndef ODMMAINBODY_H_
#define ODMMAINBODY_H_

#include <gtk/gtk.h>

#include "otak-lib/otak-db/otdbconnection.h"
#include "odmdefine.h"

typedef struct _OdmMainBody OdmMainBody;

struct _OdmMainBody
{
    GtkWidget       *container;
    GtkWidget       *hpaned;
    
    GtkWidget       *schema_table;
    GtkWidget       *schema_notebook;
    GtkWidget       *schema_table_scrolled;
    GtkWidget       *schema_index_scrolled;
    GtkWidget       *schema_procedure_scrolled;
    GtkWidget       *schema_table_treeview;
    GtkWidget       *schema_index_treeview;
    GtkWidget       *schema_procedure_treeview;

    GtkWidget       *content_notebook;

    GtkWidget       *connections_alignment;

    OtDbConnection  *conn;
};

OdmMainBody*    odm_main_body_new                           (OtDbConnection *conn);
OdmMainBody*    odm_main_body_free                          (OdmMainBody *main_body);
GtkWidget*      odm_main_body_get_base_widget               (OdmMainBody *main_body);
void            odm_main_body_set_schema_row_activated_cb   (OdmMainBody    *main_body,
                                                             OdmSchemaType   type,
                                                             GCallback       cb,
                                                             gpointer        user_data);
void            odm_main_body_contain_connections           (OdmMainBody    *main_body,
                                                             GtkWidget      *connections);
void            odm_main_body_return_self_container         (OdmMainBody *main_body);
GtkWidget*      odm_main_body_get_content_noteook           (OdmMainBody *main_body);
OdmSchemaType   odm_main_body_get_active_schema_type        (OdmMainBody *main_body);
gchar*          odm_main_body_dup_selected_schema_name      (OdmMainBody *main_body);
gboolean        odm_main_body_refresh_schema_table          (OdmMainBody *main_body);
gboolean        odm_main_body_refresh_schema_index          (OdmMainBody *main_body);
gboolean        odm_main_body_refresh_schema_procedure      (OdmMainBody *main_body);
gboolean        odm_main_body_refresh_schema_all            (OdmMainBody *main_body);

#endif /*ODMMAINBODY_H_*/
