/* 파일 설명 적는곳

   This file is part of otak-dbmanager.

   Copyright (C) 2007 Otak-dbmanager Project.

   This file is part of otak-dbmanager.

   Copyright (C) 2007 Otak-dbmanager Project.

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 3, or (at your option) any later
   version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
   Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this program; if not, write to the Free Software Foundation, Inc.,
   51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  
*/

#ifndef OTDBCOLUMN_H_
#define OTDBCOLUMN_H_

#include <glib-object.h>

#include "otdbdefine.h"

G_BEGIN_DECLS

#define OT_TYPE_DB_COLUMN               (ot_db_column_get_type ())
#define OT_DB_COLUMN(object)            (G_TYPE_CHECK_INSTANCE_CAST ((object), OT_TYPE_DB_COLUMN, OtDbColumn))
#define OT_DB_COLUMN_CLASS(klass)       (G_TYPE_CHECK_CLASS_CAST ((klass), OT_TYPE_DB_COLUMN, OtDbColumnClass))
#define OT_IS_DB_COLUMN(object)         (G_TYPE_CHECK_INSTANCE_TYPE ((object), OT_TYPE_DB_COLUMN))
#define OT_IS_DB_COLUMN_CLASS(klass)    (G_TYPE_CHECK_CLASS_TYPE ((klass), OT_TYPE_DB_COLUMN))
#define OT_DB_COLUMN_GET_CLASS(object)  (G_TYPE_INSTANCE_GET_CLASS ((object), OT_TYPE_DB_COLUMN, OtDbColumnClass))


typedef struct _OtDbColumn      OtDbColumn;
typedef struct _OtDbColumnClass OtDbColumnClass;
typedef struct _OtDbColumnData  OtDbColumnData;

struct _OtDbColumn
{
    GInitiallyUnowned parent_instance;

    gint             order;
    gchar           *name;
    OtDbCType        ctype;
    gint             size;
    gint             scale;
    gboolean         not_null;
    gchar           *default_value;
    gchar           *comment;
    gint             pkey_order;
    gboolean         unique;
    gboolean         index;
};

struct _OtDbColumnClass
{
    GInitiallyUnownedClass parent_class;

    void        (*set_type)         (OtDbColumn *column, gpointer dbtype, gint size);
    gboolean    (*is_using_where)   (OtDbColumn *column);
    gchar*      (*dup_type_name)    (OtDbColumn *column);
};

struct _OtDbColumnData
{
    gint        column_index;
    OtDbCType   ctype;
    gpointer    dbtype;
    gpointer    data;
    gint        size;
};

GType           ot_db_column_get_type       (void);
void            ot_db_column_set_type       (OtDbColumn *column,
                                             gpointer    dbtype,
                                             gint        size);
GType           ot_db_column_get_g_type     (OtDbColumn *column);
GType*          ot_db_column_dup_g_types    (GPtrArray *array);
gboolean        ot_db_column_is_using_where (OtDbColumn *column);
gchar*          ot_db_column_dup_type_name  (OtDbColumn *column);
OtDbColumnData* ot_db_column_data_free      (OtDbColumnData *column_data);

G_END_DECLS

#endif /*OTDBCOLUMN_H_*/
