/* 파일 설명 적는곳

   This file is part of otak-dbmanager.

   Copyright (C) 2007 Otak-dbmanager Project.

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 3, or (at your option) any later
   version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
   Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this program; if not, write to the Free Software Foundation, Inc.,
   51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  
*/

#ifndef OTDBCONNECTIONCUB_H_
#define OTDBCONNECTIONCUB_H_

#include "otdbconnection.h"

G_BEGIN_DECLS

#define OT_TYPE_DB_CONNECTION_CUB               (ot_db_connection_cub_get_type ())
#define OT_DB_CONNECTION_CUB(obj)               (G_TYPE_CHECK_INSTANCE_CAST ((obj), OT_TYPE_DB_CONNECTION_CUB, OtDbConnectionCub))
#define OT_DB_CONNECTION_CUB_CLASS(klass)       (G_TYPE_CHECK_CLASS_CAST ((klass), OT_TYPE_DB_CONNECTION_CUB, OtDbConnectionCubClass))
#define OT_IS_DB_CONNECTION_CUB(obj)            (G_TYPE_CHECK_INSTANCE_TYPE ((obj), OT_TYPE_DB_CONNECTION_CUB))
#define OT_IS_DB_CONNECTION_CUB_CLASS(klass)    (G_TYPE_CHECK_CLASS_TYPE ((klass), OT_TYPE_DB_CONNECTION_CUB))
#define OT_DB_CONNECTION_CUB_GET_CLASS(obj)     (G_TYPE_INSTANCE_GET_CLASS ((obj), OT_TYPE_DB_CONNECTION_CUB, OtDbConnectionCubClass))


typedef struct _OtDbConnectionCub      OtDbConnectionCub;
typedef struct _OtDbConnectionCubClass OtDbConnectionCubClass;

struct _OtDbConnectionCub
{
    OtDbConnection  connection;

    gint     conn_handle;
    gint     err_code;
    gchar   *err_msg;

    gchar   *host;
    gint     port;
    gchar   *database;
};

struct _OtDbConnectionCubClass
{
    OtDbConnectionClass parent_class;
};

GType           ot_db_connection_cub_get_type   (void);
OtDbConnection* ot_db_connection_cub_new        (const gchar    *url,
                                                 const gchar    *username,
                                                 const gchar    *password,
                                                 const gchar    *encoding);

G_END_DECLS

#endif /*OTDBCONNECTIONCUB_H_*/
