/* 파일 설명 적는곳

   This file is part of otak-dbmanager.

   Copyright (C) 2007 Otak-dbmanager Project.

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 3, or (at your option) any later
   version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
   Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this program; if not, write to the Free Software Foundation, Inc.,
   51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  
*/

#ifndef OTDBDEFINE_H_
#define OTDBDEFINE_H_

#include <glib.h>

#define OT_DB_DEFAULT_ENCODING "UTF-8"

typedef enum
{
    OT_DB_C_TYPE_NONE,
    OT_DB_C_TYPE_INT,
    OT_DB_C_TYPE_INT64,
    OT_DB_C_TYPE_FLOAT,
    OT_DB_C_TYPE_DOUBLE,
    OT_DB_C_TYPE_STR,
    OT_DB_C_TYPE_STR_DATE,
    OT_DB_C_TYPE_STR_DATETIME,
    OT_DB_C_TYPE_STR_TIME,
    OT_DB_C_TYPE_STR_BUF,      // 저용량
    OT_DB_C_TYPE_FILENAME,
    OT_DB_C_TYPE_FD,
    OT_DB_C_TYPE_OBJECT,
    OT_DB_C_TYPE_COLLECTION
} OtDbCType;

typedef enum
{
    OT_DB_PARAM_ERR_NONE,
    OT_DB_PARAM_ERR_PREPARE,
    OT_DB_PARAM_ERR_NOT_SUPPORT_TYPE,
    OT_DB_PARAM_ERR_UNKNOWN_TYPE,
    OT_DB_PARAM_ERR_MISMATCH_TYPE,
    OT_DB_PARAM_ERR_NOT_FOUND,
    OT_DB_PARAM_ERR_OUT_BOUND,
    OT_DB_PARAM_ERR_SYSTEM,
    OT_DB_PARAM_ERR_UNKNOWN
} OtDbParamErr;

typedef enum
{
    OT_DB_STMT_TYPE_NONE,
    OT_DB_STMT_TYPE_GET,
    OT_DB_STMT_TYPE_PUT,
    OT_DB_STMT_TYPE_MODIFY,
    OT_DB_STMT_TYPE_OTHER
} OtDbStmtType;

typedef enum
{
    OT_DB_TABLE_TYPE_BOTH,
    OT_DB_TABLE_TYPE_NORMAL,
    OT_DB_TABLE_TYPE_SYSTEM
} OtDbTableType;

typedef struct _OtDbStrBuf OtDbStrBuf;

struct _OtDbStrBuf
{
    gint     size;
    gchar   *data;
};

#endif /*OTDBDEFINE_H_*/
