/* 파일 설명 적는곳

   This file is part of otak-dbmanager.

   Copyright (C) 2007 Otak-dbmanager Project.

   This file is part of otak-dbmanager.

   Copyright (C) 2007 Otak-dbmanager Project.

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 3, or (at your option) any later
   version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
   Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this program; if not, write to the Free Software Foundation, Inc.,
   51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  
*/

#include <glib-object.h>

#include "otdbindexkey.h"


static gpointer parent_class = NULL;



static void
ot_db_index_key_dispose (GObject *gobject)
{
    OtDbIndexKey *index_key = OT_DB_INDEX_KEY (gobject);

    if (index_key->index_name != NULL)
    {
        g_free (index_key->index_name);
        index_key->index_name = NULL;
    }

    if (index_key->class_name != NULL)
    {
        g_free (index_key->class_name);
        index_key->class_name = NULL;
    }

    if (index_key->field_name != NULL)
    {
        g_free (index_key->field_name);
        index_key->field_name = NULL;
    }

    G_OBJECT_CLASS (parent_class)->dispose (gobject);
}

static void
ot_db_index_key_base_class_init (OtDbIndexKeyClass *class)
{
}

static void
ot_db_index_key_base_class_finalize (OtDbIndexKeyClass *class)
{
}

static void
ot_db_index_key_class_init (OtDbIndexKeyClass *class)
{
    GObjectClass *gobject_class = G_OBJECT_CLASS (class);

    parent_class = g_type_class_ref (G_TYPE_OBJECT);

    gobject_class->dispose = ot_db_index_key_dispose;
}

static void
ot_db_index_key_init (OtDbIndexKey       *index_key,
                   OtDbIndexKeyClass  *class)
{
    index_key->order        = 0;
    index_key->field_order  = 0;
    index_key->index_name   = NULL;
    index_key->class_name   = NULL;
    index_key->field_name   = NULL;
    index_key->pkey         = FALSE;
    index_key->unique       = FALSE;
    index_key->reverse      = FALSE;
}

GType
ot_db_index_key_get_type (void)
{
    static GType object_type = 0;

    if (!object_type)
    {
        const GTypeInfo object_info =
        {
            sizeof (OtDbIndexKeyClass),
            (GBaseInitFunc) ot_db_index_key_base_class_init,
            (GBaseFinalizeFunc) ot_db_index_key_base_class_finalize,
            (GClassInitFunc) ot_db_index_key_class_init,
            NULL,       /* class_finalize */
            NULL,       /* class_data */
            sizeof (OtDbIndexKey),
            16,     /* n_preallocs */
            (GInstanceInitFunc) ot_db_index_key_init,
            NULL,       /* value_table */
        };

        object_type = g_type_register_static (G_TYPE_INITIALLY_UNOWNED, "OtDbIndexKey", 
                &object_info, G_TYPE_FLAG_ABSTRACT);
    }

    return object_type;
}



/*
 * public
 */
