/* 파일 설명 적는곳

   This file is part of otak-dbmanager.

   Copyright (C) 2007 Otak-dbmanager Project.

   This file is part of otak-dbmanager.

   Copyright (C) 2007 Otak-dbmanager Project.

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 3, or (at your option) any later
   version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
   Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this program; if not, write to the Free Software Foundation, Inc.,
   51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  
*/

#ifndef OTDBINDEXKEY_H_
#define OTDBINDEXKEY_H_

#include <glib-object.h>

#include "otdbdefine.h"

G_BEGIN_DECLS

#define OT_TYPE_DB_INDEX_KEY                (ot_db_index_key_get_type ())
#define OT_DB_INDEX_KEY(object)             (G_TYPE_CHECK_INSTANCE_CAST ((object), OT_TYPE_DB_INDEX_KEY, OtDbIndexKey))
#define OT_DB_INDEX_KEY_CLASS(klass)        (G_TYPE_CHECK_CLASS_CAST ((klass), OT_TYPE_DB_INDEX_KEY, OtDbIndexKeyClass))
#define OT_IS_DB_INDEX_KEY(object)          (G_TYPE_CHECK_INSTANCE_TYPE ((object), OT_TYPE_DB_INDEX_KEY))
#define OT_IS_DB_INDEX_KEY_CLASS(klass)     (G_TYPE_CHECK_CLASS_TYPE ((klass), OT_TYPE_DB_INDEX_KEY))
#define OT_DB_INDEX_KEY_GET_CLASS(object)   (G_TYPE_INSTANCE_GET_CLASS ((object), OT_TYPE_DB_INDEX_KEY, OtDbIndexKeyClass))


typedef struct _OtDbIndexKey      OtDbIndexKey;
typedef struct _OtDbIndexKeyClass OtDbIndexKeyClass;
typedef struct _OtDbIndexKeyData  OtDbIndexKeyData;

struct _OtDbIndexKey
{
    GInitiallyUnowned parent_instance;

    gint             order;
    gint             field_order;
    gchar           *index_name;
    gchar           *class_name;
    gchar           *field_name;
    gboolean         pkey;
    gboolean         unique;
    gboolean         reverse;
};

struct _OtDbIndexKeyClass
{
    GInitiallyUnownedClass parent_class;
};

GType ot_db_index_key_get_type (void);

G_END_DECLS

#endif /*OTDBINDEXKEY_H_*/
