#include "otdbutil.h"

gchar*
ot_db_util_dup_str_value (OtDbCType ctype,
                          gpointer  value)
{
    if (value == NULL)
    {
        return g_strdup ("(null)");
    }

    switch (ctype)
    {
        case OT_DB_C_TYPE_INT:
            return g_strdup_printf ("%d", *(gint *) value);
        break;

        case OT_DB_C_TYPE_INT64:
            return g_strdup_printf ("%lld", *(gint64 *) value);
        break;

        case OT_DB_C_TYPE_FLOAT:
            return g_strdup_printf ("%f", *(gfloat *) value);
        break;

        case OT_DB_C_TYPE_DOUBLE:
            return g_strdup_printf ("%f", *(gdouble *) value);
        break;

        case OT_DB_C_TYPE_STR:
        case OT_DB_C_TYPE_STR_DATE:
        case OT_DB_C_TYPE_STR_DATETIME:
        case OT_DB_C_TYPE_STR_TIME:
        case OT_DB_C_TYPE_FILENAME:
            return g_strdup (value);
        break;

        case OT_DB_C_TYPE_STR_BUF:
        case OT_DB_C_TYPE_FD:
            return g_strdup ("(blob)");
        break;

        case OT_DB_C_TYPE_OBJECT:
            return g_strdup ("(object)");
        break;

        case OT_DB_C_TYPE_COLLECTION:
            return g_strdup ("(collection)");
        break;

        default:
        break;
    }

    return NULL;
}
