/* 파일 설명 적는곳

   This file is part of otak-dbmanager.

   Copyright (C) 2007 Otak-dbmanager Project.

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 3, or (at your option) any later
   version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
   Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this program; if not, write to the Free Software Foundation, Inc.,
   51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  
*/

#ifndef OTSTRING_H_
#define OTSTRING_H_

#include <glib.h>

gchar*      ot_string_dup_ftrim     (const gchar *str);
gchar*      ot_string_dup_rtrim     (const gchar *str);
gchar*      ot_string_dup_trim      (const gchar *str);
gboolean    ot_string_is_numeric    (const gchar *str);
gboolean    ot_string_is_float      (const gchar *str);
gboolean    ot_string_is_alpha      (const gchar *str);
gboolean    ot_string_is_alphanum   (const gchar *str);
gboolean    ot_string_is_onebyte    (const gchar *str);
gboolean    ot_string_equals        (const gchar    *str1,
                                     const gchar    *str2);
gboolean    ot_string_is_empty      (const gchar *str);

#endif /*OTSTRING_H_*/
