/* 파일 설명 적는곳

   This file is part of otak-dbmanager.

   Copyright (C) 2007 Otak-dbmanager Project.

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 3, or (at your option) any later
   version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
   Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this program; if not, write to the Free Software Foundation, Inc.,
   51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  
*/

#ifndef OTXML_H_
#define OTXML_H_

#include <libxml/xmlmemory.h>
#include <libxml/parser.h>

xmlDocPtr   ot_xml_new                  (const gchar *filename);
xmlDocPtr   ot_xml_free                 (xmlDocPtr xml_doc);
xmlNodePtr  ot_xml_get_child_node       (xmlNodePtr node,
                                         ...);
xmlNodePtr  ot_xml_add_child_node       (xmlNodePtr      parent,
                                         const gchar    *name,
                                         const gchar    *value);
xmlNodePtr  ot_xml_remove_node          (xmlNodePtr node);
gboolean    ot_xml_remove_child_node    (xmlNodePtr      parent,
                                         const gchar    *name,
                                         gint            index);
gchar*      ot_xml_dup_value            (xmlDocPtr  xml_doc,
                                         xmlNodePtr node);
void        ot_xml_set_value            (xmlNodePtr      node,
                                         const gchar    *value);
gchar*      ot_xml_dup_attribute        (xmlNodePtr      node,
                                         const gchar    *attr_name);
void        ot_xml_set_attribute        (xmlNodePtr      node,
                                         const gchar    *attr_name,
                                         const gchar    *value);


#endif /*OTXML_H_*/
