/* 파일 설명 적는곳

   This file is part of otak-dbmanager.

   Copyright (C) 2007 Otak-dbmanager Project.

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 3, or (at your option) any later
   version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
   Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this program; if not, write to the Free Software Foundation, Inc.,
   51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  
*/

#ifndef OTGRIDRENDERERTEXT_H_
#define OTGRIDRENDERERTEXT_H_


#include <gtk/gtkcellrenderertext.h>

G_BEGIN_DECLS

#define OT_TYPE_GRID_RENDERER_TEXT            (ot_grid_renderer_text_get_type ())
#define OT_GRID_RENDERER_TEXT(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), OT_TYPE_GRID_RENDERER_TEXT, OtGridRendererText))
#define OT_GRID_RENDERER_TEXT_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass), OT_TYPE_GRID_RENDERER_TEXT, OtGridRendererTextClass))
#define OT_IS_GRID_RENDERER_TEXT(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), OT_TYPE_GRID_RENDERER_TEXT))
#define OT_IS_GRID_RENDERER_TEXT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), OT_TYPE_GRID_RENDERER_TEXT))
#define OT_GRID_RENDERER_TEXT_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj), OT_TYPE_GRID_RENDERER_TEXT, OtGridRendererTextClass))


typedef struct _OtGridRendererText      OtGridRendererText;
typedef struct _OtGridRendererTextClass OtGridRendererTextClass;

struct _OtGridRendererText
{
    GtkCellRendererText renderer;

    gint    column_index;
    gint    renderer_index;

    gboolean (* start_editing_aft) (GtkCellRenderer         *cell,
                                    GdkEvent                *event,
                                    GtkWidget               *widget,
                                    const gchar             *path,
                                    GdkRectangle            *background_area,
                                    GdkRectangle            *cell_area,
                                    GtkCellRendererState     flags,
                                    GtkCellEditable         *editable);
};

struct _OtGridRendererTextClass {
    GtkCellRendererTextClass parent_class;
};

GType               ot_grid_renderer_text_get_type              (void);
OtGridRendererText* ot_grid_renderer_text_new                   (void);
void                ot_grid_renderer_text_set_column_index      (OtGridRendererText *renderer,
                                                                 gint                column_index);
void                ot_grid_renderer_text_set_renderer_index    (OtGridRendererText *renderer,
                                                                 gint                renderer_index);
void                ot_grid_renderer_text_set_start_editing_aft (OtGridRendererText *renderer,
                                                                 gpointer            start_editing_aft);

G_END_DECLS

#endif /*OTGRIDRENDERERTEXT_H_*/
