/* 파일 설명 적는곳

   This file is part of otak-dbmanager.

   Copyright (C) 2007 Otak-dbmanager Project.

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 3, or (at your option) any later
   version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
   Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this program; if not, write to the Free Software Foundation, Inc.,
   51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  
*/

#ifndef OTNOTEBOOKPAGE_H_
#define OTNOTEBOOKPAGE_H_

#include <gtk/gtktable.h>
#include <gtk/gtknotebook.h>

#include "../otdefine.h"

G_BEGIN_DECLS

#define OT_TYPE_NOTEBOOK_PAGE               (ot_notebook_page_get_type ())
#define OT_NOTEBOOK_PAGE(obj)               (G_TYPE_CHECK_INSTANCE_CAST ((obj), OT_TYPE_NOTEBOOK_PAGE, OtNotebookPage))
#define OT_NOTEBOOK_PAGE_CLASS(klass)       (G_TYPE_CHECK_CLASS_CAST ((klass), OT_TYPE_NOTEBOOK_PAGE, OtNotebookPageClass))
#define OT_IS_NOTEBOOK_PAGE(obj)            (G_TYPE_CHECK_INSTANCE_TYPE ((obj), OT_TYPE_NOTEBOOK_PAGE))
#define OT_IS_NOTEBOOK_PAGE_CLASS(klass)    (G_TYPE_CHECK_CLASS_TYPE ((klass), OT_TYPE_NOTEBOOK_PAGE))
#define OT_NOTEBOOK_PAGE_GET_CLASS(obj)     (G_TYPE_INSTANCE_GET_CLASS ((obj), OT_TYPE_NOTEBOOK_PAGE, OtNotebookPageClass))


typedef struct _OtNotebookPage      OtNotebookPage;
typedef struct _OtNotebookPageClass OtNotebookPageClass;

struct _OtNotebookPage
{
    GtkTable     table;
    GtkWidget   *tab_image;
    GtkWidget   *tab_label;
    GtkWidget   *tab_destroy_button;

    GtkWidget   *notebook;
    GtkWidget   *child;

    OtCallback  destroy_callback;

    gpointer    ref_data;
};

struct _OtNotebookPageClass {
    GtkTableClass parent_class;
};

GType           ot_notebook_page_get_type                   (void);
OtNotebookPage* ot_notebook_page_new                        (GtkNotebook    *notebook,
                                                             GtkWidget      *child,
                                                             gboolean        show_destroy_button,
                                                             gpointer        ref_data);
void            ot_notebook_page_remove                     (OtNotebookPage *notebook_page);
gint            ot_notebook_page_get_page_num               (OtNotebookPage *notebook_page);
void            ot_notebook_page_set_tab_image_from_stock   (OtNotebookPage *notebook_page,
                                                             const gchar    *stock_id);
void            ot_notebook_page_set_tab_image_from_pixbuf  (OtNotebookPage *notebook_page,
                                                             const gchar    *filename);
void            ot_notebook_page_set_tab_label              (OtNotebookPage *notebook_page,
                                                             const gchar    *label_text);

G_END_DECLS

#endif /*OTNOTEBOOK_PAGE_H_*/
