/* 파일 설명 적는곳

   This file is part of otak-dbmanager.

   Copyright (C) 2007 Otak-dbmanager Project.

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 3, or (at your option) any later
   version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
   Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this program; if not, write to the Free Software Foundation, Inc.,
   51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  
*/

#ifndef OTVALUE_H_
#define OTVALUE_H_

#include <gtk/gtk.h>

typedef enum
{
  OT_VALUE_VALID_NONE       = 0,
  OT_VALUE_VALID_REQUIRE    = 1 << 0,
  OT_VALUE_VALID_NUMERIC    = 1 << 1,
  OT_VALUE_VALID_ALPHA      = 1 << 2,
  OT_VALUE_VALID_ALPHANUM   = 1 << 3,
  OT_VALUE_VALID_ONEBYTE    = 1 << 4,
  OT_VALUE_VALID_LENGTH     = 1 << 5
} OtValueValidFlag;

typedef struct _OtValue OtValue;

struct _OtValue
{
    GtkWidget           *widget;
    gchar               *name;
    gchar               *default_value;
    gint                 min;
    gint                 max;
    OtValueValidFlag     valid_flags;
};

OtValue*            ot_value_new            (GtkWidget          *widget,
                                             const gchar        *name,
                                             const gchar        *default_value,
                                             OtValueValidFlag    valid_flags);
OtValue*            ot_value_free           (OtValue *otvalue);
OtValueValidFlag    ot_value_get_valid_err  (OtValue *otvalue);
const gchar*        ot_value_get_value      (OtValue *otvalue);
void                ot_value_set_value      (OtValue        *otvalue,
                                             const gchar    *value);
void                ot_value_set_length     (OtValue    *otvalue,
                                             gint        min,
                                             gint        max);

#endif /*OTVALUE_H_*/
