/* 파일 설명 적는곳

   This file is part of otak-dbmanager.

   Copyright (C) 2007 Otak-dbmanager Project.

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 3, or (at your option) any later
   version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
   Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this program; if not, write to the Free Software Foundation, Inc.,
   51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  
*/

#include "odmvalidation.h"

gchar*
odm_validation_dup_err_msg (OtValue *otvalue)
{
    OtValueValidFlag flags = ot_value_get_valid_err (otvalue);

    if (flags == OT_VALUE_VALID_NONE)
    {
        return NULL;
    }

    if (flags & OT_VALUE_VALID_REQUIRE)
    {
        return g_strdup_printf (ODM_VALIDATION_MSG_REQUIRE, otvalue->name);
    }

    if (flags & OT_VALUE_VALID_NUMERIC)
    {
        return g_strdup_printf (ODM_VALIDATION_MSG_NUMERIC, otvalue->name);
    }

    if (flags & OT_VALUE_VALID_ALPHA)
    {
        return g_strdup_printf (ODM_VALIDATION_MSG_ALPHA, otvalue->name);
    }

    if (flags & OT_VALUE_VALID_ALPHANUM)
    {
        return g_strdup_printf (ODM_VALIDATION_MSG_ALPHANUM, otvalue->name);
    }

    if (flags & OT_VALUE_VALID_ONEBYTE)
    {
        return g_strdup_printf (ODM_VALIDATION_MSG_ONEBYTE, otvalue->name);
    }

    if (flags & OT_VALUE_VALID_LENGTH)
    {
        return g_strdup_printf (ODM_VALIDATION_MSG_LENGTH, otvalue->name, otvalue->min, otvalue->max);
    }

    return NULL;
}
