/* 파일 설명 적는곳

   This file is part of otak-dbmanager.

   Copyright (C) 2007 Otak-dbmanager Project.

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 3, or (at your option) any later
   version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
   Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this program; if not, write to the Free Software Foundation, Inc.,
   51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  
*/

#ifndef ODMCONNINFO_H_
#define ODMCONNINFO_H_

#include <glib-object.h>

#include "../otak-lib/otak-db/otdbconnection.h"

G_BEGIN_DECLS

#define ODM_TYPE_CONN_INFO               (odm_conn_info_get_type ())
#define ODM_CONN_INFO(object)            (G_TYPE_CHECK_INSTANCE_CAST ((object), ODM_TYPE_CONN_INFO, OdmConnInfo))
#define ODM_CONN_INFO_CLASS(klass)       (G_TYPE_CHECK_CLASS_CAST ((klass), ODM_TYPE_CONN_INFO, OdmConnInfoClass))
#define ODM_IS_CONN_INFO(object)         (G_TYPE_CHECK_INSTANCE_TYPE ((object), ODM_TYPE_CONN_INFO))
#define ODM_IS_CONN_INFO_CLASS(klass)    (G_TYPE_CHECK_CLASS_TYPE ((klass), ODM_TYPE_CONN_INFO))
#define ODM_CONN_INFO_GET_CLASS(object)  (G_TYPE_INSTANCE_GET_CLASS ((object), ODM_TYPE_CONN_INFO, OdmConnInfoClass))


typedef struct _OdmConnInfo      OdmConnInfo;
typedef struct _OdmConnInfoClass OdmConnInfoClass;

struct _OdmConnInfo
{
    GInitiallyUnowned parent_instance;

    gchar       *name;
    gpointer     ref_data;
};

struct _OdmConnInfoClass
{
    GInitiallyUnownedClass parent_class;

    gchar*          (*dup_url_for_ot_db)    (OdmConnInfo *conn_info);
    OtDbConnection* (*new_ot_db_connection) (OdmConnInfo *conn_info);
};

GType           odm_conn_info_get_type              (void);
void            odm_conn_info_set_ref_data          (OdmConnInfo    *conn_info,
                                                     gpointer        ref_data);
gchar*          odm_conn_info_dup_url_for_ot_db     (OdmConnInfo *conn_info);
OtDbConnection* odm_conn_info_new_ot_db_connection  (OdmConnInfo *conn_info);

G_END_DECLS

#endif /*ODMCONNINFO_H_*/
