/* 파일 설명 적는곳

   This file is part of otak-dbmanager.

   Copyright (C) 2007 Otak-dbmanager Project.

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 3, or (at your option) any later
   version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
   Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this program; if not, write to the Free Software Foundation, Inc.,
   51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  
*/

#ifndef ODMCONNINFOCUB_H_
#define ODMCONNINFOCUB_H_

#include "odmconninfo.h"

G_BEGIN_DECLS

#define ODM_TYPE_CONN_INFO_CUB              (odm_conn_info_cub_get_type ())
#define ODM_CONN_INFO_CUB(obj)              (G_TYPE_CHECK_INSTANCE_CAST ((obj), ODM_TYPE_CONN_INFO_CUB, OdmConnInfoCub))
#define ODM_CONN_INFO_CUB_CLASS(klass)      (G_TYPE_CHECK_CLASS_CAST ((klass), ODM_TYPE_CONN_INFO_CUB, OdmConnInfoCubClass))
#define ODM_IS_CONN_INFO_CUB(obj)           (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ODM_TYPE_CONN_INFO_CUB))
#define ODM_IS_CONN_INFO_CUB_CLASS(klass)   (G_TYPE_CHECK_CLASS_TYPE ((klass), ODM_TYPE_CONN_INFO_CUB))
#define ODM_CONN_INFO_CUB_GET_CLASS(obj)    (G_TYPE_INSTANCE_GET_CLASS ((obj), ODM_TYPE_CONN_INFO_CUB, OdmConnInfoCubClass))


typedef struct _OdmConnInfoCub      OdmConnInfoCub;
typedef struct _OdmConnInfoCubClass OdmConnInfoCubClass;

struct _OdmConnInfoCub
{
    OdmConnInfo  conn_info;

    gchar   *host;
    gchar   *port;
    gchar   *database;
    gchar   *username;
    gchar   *password;
    gchar   *encoding;
};

struct _OdmConnInfoCubClass {
    OdmConnInfoClass parent_class;
};

GType           odm_conn_info_cub_get_type  (void);
OdmConnInfo*    odm_conn_info_cub_new       (const gchar    *name,
                                             const gchar    *host,
                                             const gchar    *port,
                                             const gchar    *database,
                                             const gchar    *username,
                                             const gchar    *password,
                                             const gchar    *encoding);

G_END_DECLS

#endif /*ODMCONNINFOCUB_H_*/
