#include <glib.h>

#include "../otak-lib/otak-util/otstring.h"
#include "../otak-lib/otak-widget/otvalue.h"
#include "odmconninfocub.h"
#include "odmconninfofactory.h"



static OdmConnInfo*
odm_conn_info_factory_new_instance_cub (GPtrArray *otvalue_list)
{
    const gchar *name       = NULL;
    const gchar *host       = NULL;
    const gchar *port       = NULL;
    const gchar *database   = NULL;
    const gchar *username   = NULL;
    const gchar *password   = NULL;
    const gchar *encoding   = NULL;

    gint i = 0;
    for (i = 0; i < otvalue_list->len; i++)
    {
        OtValue     *otvalue    = (OtValue *) g_ptr_array_index (otvalue_list, i);
        const gchar *value      = ot_value_get_value (otvalue);

        if (ot_string_equals (otvalue->name, ODM_CONN_INFO_FIELD_NAME_NAME))
        {
            name = value;
        }
        else if (ot_string_equals (otvalue->name, ODM_CONN_INFO_FIELD_NAME_HOST))
        {
            host = value;
        }
        else if (ot_string_equals (otvalue->name, ODM_CONN_INFO_FIELD_NAME_PORT))
        {
            port = value;
        }
        else if (ot_string_equals (otvalue->name, ODM_CONN_INFO_FIELD_NAME_DATABASE))
        {
            database = value;
        }
        else if (ot_string_equals (otvalue->name, ODM_CONN_INFO_FIELD_NAME_USERNAME))
        {
            username = value;
        }
        else if (ot_string_equals (otvalue->name, ODM_CONN_INFO_FIELD_NAME_PASSWORD))
        {
            password = value;
        }
        else if (ot_string_equals (otvalue->name, ODM_CONN_INFO_FIELD_NAME_ENCODING))
        {
            encoding = value;
        }
    }

    return odm_conn_info_cub_new (name, host, port, database,
            username, password, encoding);
}

OdmConnInfo*
odm_conn_info_factory_new_instance (OdmConnInfoProv  prov,
                                    GPtrArray       *otvalue_list)
{
    OdmConnInfo *conn_info = NULL;

    switch (prov)
    {
        case ODM_CONN_INFO_PROV_CUB:
            conn_info = odm_conn_info_factory_new_instance_cub (otvalue_list);
        break;

        default:
        break;
    }

    return conn_info;
}
