/* 파일 설명 적는곳

   This file is part of otak-dbmanager.

   Copyright (C) 2007 Otak-dbmanager Project.

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 3, or (at your option) any later
   version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
   Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this program; if not, write to the Free Software Foundation, Inc.,
   51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  
*/

#ifndef ODMCOLUMNBROWSER_H_
#define ODMCOLUMNBROWSER_H_

#include <gtk/gtktable.h>

#include "../otak-lib/otak-db/otdbconnection.h"
#include "../otak-lib/otak-widget/otgrid.h"

G_BEGIN_DECLS

#define ODM_TYPE_COLUMN_BROWSER             (odm_column_browser_get_type ())
#define ODM_COLUMN_BROWSER(obj)             (G_TYPE_CHECK_INSTANCE_CAST ((obj), ODM_TYPE_COLUMN_BROWSER, OdmColumnBrowser))
#define ODM_COLUMN_BROWSER_CLASS(klass)     (G_TYPE_CHECK_CLASS_CAST ((klass), ODM_TYPE_COLUMN_BROWSER, OdmColumnBrowserClass))
#define ODM_IS_COLUMN_BROWSER(obj)          (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ODM_TYPE_COLUMN_BROWSER))
#define ODM_IS_COLUMN_BROWSER_CLASS(klass)  (G_TYPE_CHECK_CLASS_TYPE ((klass), ODM_TYPE_COLUMN_BROWSER))
#define ODM_COLUMN_BROWSER_GET_CLASS(obj)   (G_TYPE_INSTANCE_GET_CLASS ((obj), ODM_TYPE_COLUMN_BROWSER, OdmColumnBrowserClass))

#define ODM_COLUMN_BROWSER_ACT_BTN_CNT 3
#define ODM_COLUMN_BROWSER_COLUMN_CNT 13


typedef struct _OdmColumnBrowser        OdmColumnBrowser;
typedef struct _OdmColumnBrowserClass   OdmColumnBrowserClass;

struct _OdmColumnBrowser
{
    GtkTable table;

    GtkWidget   *scrolled;
    OtGrid      *grid;
    GtkWidget   *action_table;
    GtkWidget   *action_buttons[ODM_COLUMN_BROWSER_ACT_BTN_CNT];

    OtDbConnection  *shared_db_conn;
    gchar           *table_name;
};

struct _OdmColumnBrowserClass
{
    GtkTableClass parent_class;
};

GType               odm_column_browser_get_type             (void);
OdmColumnBrowser*   odm_column_browser_new                  (void);
void                odm_column_browser_dupset_db            (OdmColumnBrowser   *browser,
                                                             OtDbConnection     *shared_db_conn,
                                                             const gchar        *table_name);
void                odm_column_browser_show_action_table    (OdmColumnBrowser   *browser,
                                                             gboolean            show);
void                odm_column_browser_button_loading       (OdmColumnBrowser   *browser,
                                                             const gchar        *image_dir);

G_END_DECLS

#endif /*ODMCOLUMNBROWSER_H_*/
