/* 파일 설명 적는곳

   This file is part of otak-dbmanager.

   Copyright (C) 2007 Otak-dbmanager Project.

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 3, or (at your option) any later
   version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
   Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this program; if not, write to the Free Software Foundation, Inc.,
   51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  
*/

#ifndef ODMDATABROWSER_H_
#define ODMDATABROWSER_H_

#include <gtk/gtktable.h>

#include "../otak-lib/otak-db/otdbconnection.h"
#include "../otak-lib/otak-db/otdbdataset.h"
#include "../otak-lib/otak-db-control/otdbgrid.h"

G_BEGIN_DECLS

#define ODM_TYPE_DATA_BROWSER               (odm_data_browser_get_type ())
#define ODM_DATA_BROWSER(obj)               (G_TYPE_CHECK_INSTANCE_CAST ((obj), ODM_TYPE_DATA_BROWSER, OdmDataBrowser))
#define ODM_DATA_BROWSER_CLASS(klass)       (G_TYPE_CHECK_CLASS_CAST ((klass), ODM_TYPE_DATA_BROWSER, OdmDataBrowserClass))
#define ODM_IS_DATA_BROWSER(obj)            (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ODM_TYPE_DATA_BROWSER))
#define ODM_IS_DATA_BROWSER_CLASS(klass)    (G_TYPE_CHECK_CLASS_TYPE ((klass), ODM_TYPE_DATA_BROWSER))
#define ODM_DATA_BROWSER_GET_CLASS(obj)     (G_TYPE_INSTANCE_GET_CLASS ((obj), ODM_TYPE_DATA_BROWSER, OdmDataBrowserClass))

#define ODM_DATA_BROWSER_NAVI_BTN_CNT 9
#define ODM_DATA_BROWSER_EDIT_BTN_CNT 1


typedef struct _OdmDataBrowser      OdmDataBrowser;
typedef struct _OdmDataBrowserClass OdmDataBrowserClass;

struct _OdmDataBrowser
{
    GtkTable table;

    GtkWidget   *scrolled;
    OtDbGrid    *db_grid;
    GtkWidget   *statusbar;
    GtkWidget   *action_table;
    GtkWidget   *navi_table;
    GtkWidget   *edit_table;
    GtkWidget   *navi_buttons[ODM_DATA_BROWSER_NAVI_BTN_CNT];
    GtkWidget   *edit_buttons[ODM_DATA_BROWSER_EDIT_BTN_CNT];
};

struct _OdmDataBrowserClass
{
    GtkTableClass parent_class;
};

GType           odm_data_browser_get_type           (void);
OdmDataBrowser* odm_data_browser_new                (void);
OtDbGrid*       odm_data_browser_get_db_grid        (OdmDataBrowser *browser);
void            odm_data_browser_show_action_table  (OdmDataBrowser *browser,
                                                     gboolean        show);
void            odm_data_browser_button_loading     (OdmDataBrowser *browser,
                                                     const gchar    *image_dir);
gint            odm_data_browser_next_block         (OdmDataBrowser *browser);
gboolean        odm_data_browser_refresh            (OdmDataBrowser *browser);
void            odm_data_browser_set_readonly       (OdmDataBrowser *browser,
                                                     gboolean        readonly);

G_END_DECLS

#endif /*ODMDATABROWSER_H_*/
