/* 파일 설명 적는곳

   This file is part of otak-dbmanager.

   Copyright (C) 2007 Otak-dbmanager Project.

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 3, or (at your option) any later
   version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
   Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this program; if not, write to the Free Software Foundation, Inc.,
   51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  
*/

#ifndef ODMSCHEMABROWSER_H_
#define ODMSCHEMABROWSER_H_

#include <gtk/gtknotebook.h>

#include "odmcolumnbrowser.h"
#include "odmdatabrowser.h"

G_BEGIN_DECLS

#define ODM_TYPE_SCHEMA_BROWSER               (odm_schema_browser_get_type ())
#define ODM_SCHEMA_BROWSER(obj)               (G_TYPE_CHECK_INSTANCE_CAST ((obj), ODM_TYPE_SCHEMA_BROWSER, OdmSchemaBrowser))
#define ODM_SCHEMA_BROWSER_CLASS(klass)       (G_TYPE_CHECK_CLASS_CAST ((klass), ODM_TYPE_SCHEMA_BROWSER, OdmSchemaBrowserClass))
#define ODM_IS_SCHEMA_BROWSER(obj)            (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ODM_TYPE_SCHEMA_BROWSER))
#define ODM_IS_SCHEMA_BROWSER_CLASS(klass)    (G_TYPE_CHECK_CLASS_TYPE ((klass), ODM_TYPE_SCHEMA_BROWSER))
#define ODM_SCHEMA_BROWSER_GET_CLASS(obj)     (G_TYPE_INSTANCE_GET_CLASS ((obj), ODM_TYPE_SCHEMA_BROWSER, OdmSchemaBrowserClass))

#define ODM_SCHEMA_BROWSER_NAVI_BTN_CNT 9


typedef struct _OdmSchemaBrowser      OdmSchemaBrowser;
typedef struct _OdmSchemaBrowserClass OdmSchemaBrowserClass;

struct _OdmSchemaBrowser
{
    GtkNotebook notebook;

    OdmColumnBrowser    *column_browser;
    OdmDataBrowser      *data_browser;

    gchar *err_msg;
};

struct _OdmSchemaBrowserClass
{
    GtkNotebookClass parent_class;
};

GType               odm_schema_browser_get_type (void);
OdmSchemaBrowser*   odm_schema_browser_new      (OtDbConnection  *shared_db_conn,
                                                 const gchar     *table_name,
                                                 const gchar     *image_dir,
                                                 gchar          **error);

G_END_DECLS

#endif /*ODMSCHEMABROWSER_H_*/
