/* 파일 설명 적는곳

   This file is part of otak-dbmanager.

   Copyright (C) 2007 Otak-dbmanager Project.

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 3, or (at your option) any later
   version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
   Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this program; if not, write to the Free Software Foundation, Inc.,
   51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  
*/

#ifndef ODMSQLEDITOR_H_
#define ODMSQLEDITOR_H_

#include <gtk/gtkvpaned.h>
#include "odmdatabrowser.h"

G_BEGIN_DECLS

#define ODM_TYPE_SQL_EDITOR             (odm_sql_editor_get_type ())
#define ODM_SQL_EDITOR(obj)             (G_TYPE_CHECK_INSTANCE_CAST ((obj), ODM_TYPE_SQL_EDITOR, OdmSqlEditor))
#define ODM_SQL_EDITOR_CLASS(klass)     (G_TYPE_CHECK_CLASS_CAST ((klass), ODM_TYPE_SQL_EDITOR, OdmSqlEditorClass))
#define ODM_IS_SQL_EDITOR(obj)          (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ODM_TYPE_SQL_EDITOR))
#define ODM_IS_SQL_EDITOR_CLASS(klass)  (G_TYPE_CHECK_CLASS_TYPE ((klass), ODM_TYPE_SQL_EDITOR))
#define ODM_SQL_EDITOR_GET_CLASS(obj)   (G_TYPE_INSTANCE_GET_CLASS ((obj), ODM_TYPE_SQL_EDITOR, OdmSqlEditorClass))

#define ODM_SQL_EDITOR_ACT_BTN_CNT 1


typedef struct _OdmSqlEditor      OdmSqlEditor;
typedef struct _OdmSqlEditorClass OdmSqlEditorClass;

struct _OdmSqlEditor
{
    GtkVPaned vpaned;

    GtkWidget       *edt_table;
    GtkWidget       *edt_scrolled;
    GtkWidget       *edt_textview;
    GtkWidget       *act_table;
    GtkWidget       *act_buttons[ODM_DATA_BROWSER_NAVI_BTN_CNT];
    OdmDataBrowser  *data_browser;
    gboolean         is_size_allocate;
};

struct _OdmSqlEditorClass {
    GtkVPanedClass parent_class;
};

GType           odm_sql_editor_get_type         (void);
OdmSqlEditor*   odm_sql_editor_new              (OtDbConnection  *shared_db_conn,
                                                 const gchar     *image_dir,
                                                 gchar          **error);
void            odm_sql_editor_button_loading   (OdmSqlEditor   *editor,
                                                 const gchar    *image_dir);
gchar*          odm_sql_editor_dup_full_text    (OdmSqlEditor *editor);

G_END_DECLS

#endif /*ODMSQLEDITOR_H_*/
